if(!com.ktsystems.subswitch.SetPrefix) com.ktsystems.subswitch.SetPrefix={};

com.ktsystems.subswitch.SetPrefix = {
    getItem : function (){
        var arg = window.arguments[0];
        var item;
        if (arg instanceof Components.interfaces.nsIDialogParamBlock) {
            item = new com.ktsystems.subswitch.Utils.createItem(arg.GetString(21), arg.GetString(20));
        } else {
            item = arg;
        }

        return item;
    },

    setRDOnLoad : function() {
        var item = this.getItem();

        if (item) {
            document.getElementById("rd").value = item.rd;
            document.getElementById("description").value = item.description;
            if (item.aliases) {
                com.ktsystems.subswitch.Utils.fillListboxFromArray(document.getElementById("aliasesList"), item.aliases);
            }
        }
    },

    setRDOnDialogAccept : function () {
        return this.setRDCommonAccept();
    },

    setRDCommonAccept : function() {
        var isValid = false;

        try {
            isValid = this.checkDescription() && this.checkRD();

            if (isValid) {
                var arg = window.arguments[0];
                if (arg instanceof Components.interfaces.nsIDialogParamBlock) {
                    arg.SetInt(0, 0);
                    arg.SetString(21, document.getElementById("description").value);
                    arg.SetString(20, document.getElementById("rd").value);
                 } else {
                    var item = arg;
                    if (item) {
                        item.description = document.getElementById("description").value;
                        item.rd = document.getElementById("rd").value;
                        item.aliases = com.ktsystems.subswitch.Utils.getArrayFromListbox(document.getElementById("aliasesList"));
                    }
                }
            }
        } catch (err) {
            alert(err);
        }
        return isValid;
    },

    onDialogCancel : function () {
    },

    checkDescription : function(){
        var description = document.getElementById("description");
        var isValid = this.checkElem(description);

        if (!isValid) {
            alert(
                com.ktsystems.subswitch.Utils.getLocalizedMessage("setRD.invalidDescription"));
            description.focus();
        }

        return isValid;
    },

    checkRD : function () {
        var rd = document.getElementById("rd");
        var isValid = this.checkElem(rd);

        if (!isValid) {
            alert(
                com.ktsystems.subswitch.Utils.getLocalizedMessage("setRD.invalidPath"));
            rd.focus();
        }

        return isValid;
    },

    checkElem : function(elem) {
        var isValid;

        if (elem == null || elem.value == ""
            || elem.value.indexOf(com.ktsystems.subswitch.Utils.getRDEntrySplitSign()) > -1
            || elem.value.indexOf(com.ktsystems.subswitch.Utils.getRDPrefEntriesSplitSign()) > -1) {
            isValid = false;
        } else {
            isValid = true;
        }

        return isValid;
    },

    addAlias : function(type) {
        var input = document.getElementById("alias");
        var listbox = document.getElementById("aliasesList");

        if (!this.checkElem(input)) {
            alert(
                com.ktsystems.subswitch.Utils.getLocalizedMessage("setRD.invalidAlias"));
            return;
        }

        for (var i = 0; i < listbox.getRowCount(); i++) {
            if (listbox.getItemAtIndex(i).value == input.value) {
                alert(
                    com.ktsystems.subswitch.Utils.getLocalizedMessage("setRD.duplicateAlias"));
                return;
            }
        }

        listbox.appendItem(input.value, input.value);
        listbox.ensureIndexIsVisible(listbox.getRowCount()-1);
        input.value = "";
    },

    removeAlias : function(type) {
        var listbox = document.getElementById("aliasesList");
        var selected = listbox.selectedIndex;

        if (selected >= 0)
            listbox.removeItemAt(selected);
    }
}